import{GraphQLScalarType as e}from"graphql";import{GraphQLError as r}from"graphql/error";import{Kind as n}from"graphql/language";import a from"joi";import t from"joi-postalcode";var i=function(e){return a.assert(e,a.date().iso(),new TypeError("Value is not a valid Date: "+e)),e},s="scalar DateTime",o=new e({name:"DateTime",description:"Use JavaScript Date object for date/time fields.",serialize:function(e){var r="string"==typeof e?new Date(Date.parse(e)):e;return i(r),r.toJSON()},parseValue:function(e){var r=new Date(e);return i(r)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.STRING)throw new r("Can only parse strings to dates but got a: "+a);var s=new Date(t);if(t!==s.toJSON())throw new r("Value is not a valid Date format (YYYY-MM-DDTHH:MM:SS.SSSZ): "+t);return i(s)}}),u=function(e){return a.assert(e,a.string(),new TypeError("Value is not string: "+e)),a.assert(e,a.string().email(),new TypeError("Value is not a valid email address: "+e)),e},l="scalar EmailAddress",p=new e({name:"EmailAddress",description:"A field whose value conforms to the standard internet email address format as specified in RFC822: https://www.w3.org/Protocols/rfc822/.",serialize:function(e){return u(e)},parseValue:function(e){return u(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.STRING)throw new r("Can only validate strings as email addresses but got a: "+a);return u(t)}}),f=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseFloat(e);return a.assert(r,a.number().negative(),new TypeError("Value is not a negative number: "+r)),a.assert(r,a.number().less(0),new TypeError("Value is not less than 0: "+r)),r},v="scalar NegativeFloat",m=new e({name:"NegativeFloat",description:"Floats that will have a value less than 0.",serialize:function(e){return f(e)},parseValue:function(e){return f(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.FLOAT)throw new r("Can only validate floating point numbers as negative floating point numbers but got a: "+a);return f(t)}}),w=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseInt(e,10);return a.assert(r,a.number().integer(),new TypeError("Value is not a safe integer: "+r)),a.assert(r,a.number().integer(),new TypeError("Value is not an integer: "+r)),a.assert(r,a.number().negative(),new TypeError("Value is not a negative number: "+r)),a.assert(r,a.number().less(0),new TypeError("Value is not less than 0: "+r)),r},d="scalar NegativeInt",g=new e({name:"NegativeInt",description:"Integers that will have a value less than 0.",serialize:function(e){return w(e)},parseValue:function(e){return w(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.INT)throw new r("Can only validate integers as negative integers but got a: "+a);return w(t)}}),c=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseFloat(e);return a.assert(r,a.number().max(0),new TypeError("Value is not a non-positive number: "+r)),a.assert(r,a.number().negative().allow(0),new TypeError("Value is not a negative number: "+r)),r},y="scalar NonPositiveFloat",b=new e({name:"NonPositiveFloat",description:"Floats that will have a value of 0 or less.",serialize:function(e){return c(e)},parseValue:function(e){return c(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.FLOAT)throw new r("Can only validate floating point numbers as non-positive floating point numbers but got a: "+a);return c(t)}}),T=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseInt(e,10);return a.assert(r,a.number().integer(),new TypeError("Value is not a safe integer: "+r)),a.assert(r,a.number().integer(),new TypeError("Value is not an integer: "+r)),a.assert(r,a.number().max(0),new TypeError("Value is not a non-positive number: "+r)),a.assert(r,a.number().negative().allow(0),new TypeError("Value is not a negative number: "+r)),r},h="scalar NonPositiveInt",V=new e({name:"NonPositiveInt",description:"Integers that will have a value of 0 or less.",serialize:function(e){return T(e)},parseValue:function(e){return T(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.INT)throw new r("Can only validate integers as non-positive integers but got a: "+a);return T(t)}}),E=function(e){return a.assert(e,a.string(),new TypeError("Value is not string: "+e)),a.assert(e,a.string().regex(/^\+\d{11,15}$/),new TypeError("Value is not a valid phone number of the form +17895551234 (10-15 digits): "+e)),e},I="scalar PhoneNumber",N=new e({name:"PhoneNumber",description:"A field whose value conforms to the standard E.164 format as specified in: https://en.wikipedia.org/wiki/E.164. Basically this is +17895551234.",serialize:function(e){return E(e)},parseValue:function(e){return E(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.STRING)throw new r("Can only validate strings as phone numbers but got a: "+a);return E(t)}}),F=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseFloat(e);return a.assert(r,a.number().positive(),new TypeError("Value is not a positive number: "+r)),a.assert(r,a.number().greater(0),new TypeError("Value is not greater than 0: "+r)),r},L="scalar PositiveFloat",C=new e({name:"PositiveFloat",description:"Floats that will have a value greater than 0.",serialize:function(e){return F(e)},parseValue:function(e){return F(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.FLOAT)throw new r("Can only validate floating point numbers as positive floating point numbers but got a: "+a);return F(t)}}),S=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseInt(e,10);return a.assert(r,a.number().integer(),new TypeError("Value is not a safe integer: "+r)),a.assert(r,a.number().integer(),new TypeError("Value is not an integer: "+r)),a.assert(r,a.number().positive(),new TypeError("Value is not a positive number: "+r)),a.assert(r,a.number().greater(0),new TypeError("Value is not greater than 0: "+r)),r},P="scalar PositiveInt",U=new e({name:"PositiveInt",description:"Integers that will have a value greater than 0.",serialize:function(e){return S(e)},parseValue:function(e){return S(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.INT)throw new r("Can only validate integers as positive integers but got a: "+a);return S(t)}}),k=a.extend(t),R=["US","GB","DE","CA","FR","IT","AU","NL","ES","DK","SE","BE","IN"],A=function(e){return k.assert(e,k.string(),new TypeError("Value is not string: "+e)),k.assert(e,[].concat(R.map(function(e){return k.string().postalCode(e)})),new TypeError("Value is not a valid postal code: "+e)),e},D="scalar PostalCode",z=new e({name:"PostalCode",description:"A field whose value conforms to the standard postal code formats for United States, United Kingdom, Germany, Canada, France, Italy, Australia, Netherlands, Spain, Denmark, Sweden, Belgium or India.",serialize:function(e){return A(e)},parseValue:function(e){return A(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.STRING)throw new r("Can only validate strings as phone numbers but got a: "+a);return A(t)}}),x=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseFloat(e);return a.assert(r,a.number().min(0),new TypeError("Value is not a non-negative number: "+r)),a.assert(r,a.number().positive().allow(0),new TypeError("Value is not a non-negative number/: "+r)),r},q="scalar UnsignedFloat",G=new e({name:"UnsignedFloat",description:"Floats that will have a value of 0 or more.",serialize:function(e){return x(e)},parseValue:function(e){return x(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.FLOAT)throw new r("Can only validate floating point numbers as non-negative floating point numbers but got a: "+a);return x(t)}}),O=function(e){a.assert(e,a.any().invalid(Infinity,-Infinity),new TypeError("Value is not a finite number: "+e)),a.assert(e,a.number().required(),new TypeError("Value is not a number: "+e));var r=parseInt(e,10);return a.assert(r,a.number().integer(),new TypeError("Value is not a safe integer: "+r)),a.assert(r,a.number().integer(),new TypeError("Value is not an integer: "+r)),a.assert(r,a.number().min(0),new TypeError("Value is not a non-negative number: "+r)),a.assert(r,a.number().positive().allow(0),new TypeError("Value is not a positive number: "+r)),r},M="scalar UnsignedInt",B=new e({name:"UnsignedInt",description:"Integers that will have a value of 0 or more.",serialize:function(e){return O(e)},parseValue:function(e){return O(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.INT)throw new r("Can only validate integers as non-negative integers but got a: "+a);return O(t)}}),Y=function(e){return a.assert(e,a.string(),new TypeError("Value is not string: "+e)),a.assert(e,[a.string().uri(),a.string().dataUri()],new TypeError("Value is not a valid URL: "+e)),e},j="scalar URL",J=new e({name:"URL",description:"A field whose value conforms to the standard URL format as specified in RFC3986: https://www.ietf.org/rfc/rfc3986.txt.",serialize:function(e){return Y(e)},parseValue:function(e){return Y(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.STRING)throw new r("Can only validate strings as URLs but got a: "+a);return Y(t)}}),H=function(t,i){var s=function(e){return a.assert(e,a.string(),new TypeError("Value is not string: "+e)),a.assert(e,a.string().regex(new RegExp(i),{name:t}),new TypeError("Value does not match the regular expression "+i+": "+e)),e};return{scalar:"scalar "+t,resolver:new e({name:t,description:"A field whose value matches the provided regular expression "+i+".",serialize:function(e){return s(e)},parseValue:function(e){return s(e)},parseLiteral:function(e){var a=e.kind,t=e.value;if(a!==n.STRING)throw new r("Can only validate strings as regular expressions but got a: "+a);return s(t)}})}};export default new Map([["scalar DateTime",o],["scalar EmailAddress",p],["scalar NegativeFloat",m],["scalar NegativeInt",g],["scalar NonPositiveFloat",b],["scalar NonPositiveInt",V],["scalar PhoneNumber",N],["scalar PositiveFloat",C],["scalar PositiveInt",U],["scalar PostalCode",z],["scalar UnsignedFloat",G],["scalar UnsignedInt",B],["scalar URL",J]]);export{s as DateTimeScalar,o as DateTime,l as EmailAddressScalar,p as EmailAddress,v as NegativeFloatScalar,m as NegativeFloat,d as NegativeIntScalar,g as NegativeInt,y as NonPositiveFloatScalar,b as NonPositiveFloat,h as NonPositiveIntScalar,V as NonPositiveInt,I as PhoneNumberScalar,N as PhoneNumber,L as PositiveFloatScalar,C as PositiveFloat,P as PositiveIntScalar,U as PositiveInt,D as PostalCodeScalar,z as PostalCode,q as UnsignedFloatScalar,G as UnsignedFloat,M as UnsignedIntScalar,B as UnsignedInt,j as URLScalar,J as URL,H as RegularExpressionFactory};
//# sourceMappingURL=index.mjs.map
